Index: channels/chan_iax2.c
===================================================================
--- channels/chan_iax2.c	(revision 156356)
+++ channels/chan_iax2.c	(working copy)
@@ -7534,6 +7534,13 @@
 				iaxs[fr->callno]->videoformat = f.subclass & ~0x1;
 			}
 		}
+		if (f.frametype == AST_FRAME_CONTROL && iaxs[fr->callno]->owner) {
+			if (f.subclass == AST_CONTROL_BUSY) {
+				iaxs[fr->callno]->owner->hangupcause = AST_CAUSE_BUSY;
+			} else if (f.subclass == AST_CONTROL_CONGESTION) {
+				iaxs[fr->callno]->owner->hangupcause = AST_CAUSE_CONGESTION;
+			}
+		}
 		if (f.frametype == AST_FRAME_IAX) {
 			AST_SCHED_DEL(sched, iaxs[fr->callno]->initid);
 			/* Handle the IAX pseudo frame itself */
Index: main/cdr.c
===================================================================
--- main/cdr.c	(revision 156356)
+++ main/cdr.c	(working copy)
@@ -766,6 +766,9 @@
 		case AST_CAUSE_BUSY:
 			ast_cdr_busy(cdr);
 			break;
+		case AST_CAUSE_NO_ANSWER:
+			ast_cdr_noanswer(cdr);
+			break;
 		case AST_CAUSE_NORMAL:
 			break;
 		default:
